<'
package shr_spi3;

unit shr_spi3_arbiter_u like any_unit {

   layer       : shr_spi3_layer_t;     //Layer of the agent in which this arbiter unit is instantiated.
   arb_method  : shr_spi3_arb_method_t;   //Arbitration methoed - i.e. round robin
   numports    : uint;	      	       //Number of ports in this agent
   keep soft numports < 256;
   start_port_index  : uint;  	       //Port on which arbitration should start (coming out of reset)
   port_stat   : list of bit; 	       //Port status - (1 = port available to be used)
   active_port_index : uint(bits:8);   //Index in the data port list of the current active port number

      
   event clock;
   
    keep start_port_index == 0;                   // Initial starting point is 0 since we're guaranteed at least one port
    keep port_stat.size() == numports;  // The packet available status list has one entry for each port
    keep for each (stat) in port_stat {      // The status for each port initially prevents transfers
        stat == 1'b0;
    };
   keep active_port_index == 0;   

};

extend LINK'layer shr_spi3_arbiter_u {

};

extend PHY'layer shr_spi3_arbiter_u{
};

'>
