<'
package shr_spi3;

unit shr_spi3_env_u like any_unit {
   spi3_agents : list of shr_spi3_agent_u is instance;
   keep soft spi3_agents.size() == 4; 
   
   keep for each in spi3_agents {
      it.direction == RX => it.config == spi3_agent_configs[1];
      it.direction == TX => it.config == spi3_agent_configs[0];
   };
   
   spi3_agent_configs : list of shr_spi3_agent_config_u is instance;
   keep soft spi3_agent_configs.size() == 2;
   keep for each in spi3_agent_configs {
      index == 0 => it.direction == TX;
      index == 1 => it.direction == RX;
   };
   
   keep gen (spi3_agent_configs) before (spi3_agents);  
   
   run() is also {
   
      messagef(LOW,"\n\nSPI3 eVC Instantiated\n");
      messagef(LOW,"Number of SPI3 Agents : %d\n",spi3_agents.size());
      messagef(LOW,"Number of ACTIVE SPI3 Agents : %d\n",
        spi3_agents.all(it.active_passive == ACTIVE).size());
   
   };//run is also
};

extend shr_spi3_bfm_u {
   env : shr_spi3_env_u;
   keep env == get_enclosing_unit(shr_spi3_env_u);
};

extend RX'direction PHY'layer shr_spi3_bfm_u {
};

extend TX'direction LINK'layer shr_spi3_bfm_u {
};   
'>
