<'
package shr_spi3;

extend OUT shr_spi3_port_u {

    run() is also { start manage_port_data();};		    

    event new_pkt_generated;  //Scoreboarding hook provided for scoreboarding at the port level.
    
    
    !incoming_spi3_packet : shr_spi3_packet_s;

    //-------------------------------------------------------------------
    // TCM: manage_port_data()
    //-------------------------------------------------------------------
    // This method is used to maintain a list of data bytes for the port
    // which can be used as a source for data cycles sent to the DUT.
    // Data will be pulled from higher-level protocol generators or
    // randomly generated (potentially with some intervention from the
    // end user).
    //-------------------------------------------------------------------
    manage_port_data() @sys.any is {
	var cur_transfer : shr_spi3_inport_bfmdata_s = new;
//	wait @reset_end;
	
//        while TRUE {
            if not data_avail {
               // Pull the next data list from the port data driver
		all of {
                  {incoming_spi3_packet = port_driver.get_next_item();};
		  {emit port_driver.clock;};
	        };

		emit new_pkt_generated;
      	       		
                if incoming_spi3_packet.data.size() != 0 {                      // If the driver didn't return a null string then ...
                    data_avail = TRUE;                         //    Indicate that there is valid data available
                
		
		  var data_len : uint = incoming_spi3_packet.data.size();
		  var curr_mod : uint(bits : 2);
		  if data_len%4 == 0 then {
		     curr_mod = 0;
		  } else {
		     curr_mod = 4-(data_len%4);
		  };
		
		  //Now correctly pack into the cur_data list
      	          if agent.config.mode == WIDE then {
		     if data_len <= 4 then {
		     	cur_transfer.error = FALSE;
		     	cur_transfer.data = 0;
		     	cur_transfer.sop = 1;
		     	cur_transfer.eop = 1;
		     	cur_transfer.mod = curr_mod;
      	             	for i from 0 to data_len -1 {
		     	   cur_transfer.data[(31-(i*8)):(24-(i*8))] = incoming_spi3_packet.data[i];
		     	};	
		     	cur_data.add(deep_copy(cur_transfer));
		     	cur_transfer = new;
		     } else {
		     	for j from 0 to (data_len/4 -1) {
		     	   cur_transfer.data = 0;
			   cur_transfer.error = FALSE;
		     	   for i from 0 to 3 {
			      cur_transfer.data[(31-(i*8)):(24-(i*8))] = incoming_spi3_packet.data[(j*4)+i];
			   };
			   cur_transfer.mod = 0;
			   if j == 0 then {
			      cur_transfer.sop = 1;
			      cur_transfer.eop = 0;
			   }
			   else if ((data_len%4 == 0) and (data_len/4 -1) == j) {
			      cur_transfer.sop = 0;
			      cur_transfer.eop = 1;
			   }
			   else {
			      cur_transfer.sop = 0;
			      cur_transfer.eop = 0;
			   };
			   cur_data.add(deep_copy(cur_transfer));
			   cur_transfer = new;
		     	};
		     
		     	if data_len%4 > 0 then {
		     	   cur_transfer.data = 0;
		     	   cur_transfer.eop = 1;
			   cur_transfer.sop = 0;
      	             	   cur_transfer.mod = curr_mod;
		     	   for i from (data_len-(data_len%4)) to (data_len-1) {
			      var bit_index : uint;
			      bit_index = (i + (data_len%4) - data_len);
			      cur_transfer.data[(31-(bit_index*8)):(24-(bit_index*8))] = incoming_spi3_packet.data[i];
			   }; //for i from
			   cur_data.add(deep_copy(cur_transfer));
			   cur_transfer=new;
		     	};// if data_len
		     }; //else
		  }//if agent.config.mode
		  else {//agent.config.mode == NARROW
      	             if incoming_spi3_packet.data.size() == 1 then {
		     	cur_transfer.data = 0;
		     	cur_transfer.error = FALSE;
		     	cur_transfer.sop = 1;
		     	cur_transfer.eop = 1;
		     	cur_transfer.data[7:0] = incoming_spi3_packet.data[0];
		     	cur_data.add(deep_copy(cur_transfer));
		     	cur_transfer=new;
		     }
		     else {
		     	for i from 0 to data_len-1 {
		     	   cur_transfer.data =0;
			   cur_transfer.error = FALSE;
			   if i == 0 then {
			      cur_transfer.sop = 1;
			      cur_transfer.eop = 0;
			   } else if i == data_len-1 then {
			      cur_transfer.sop = 0;
			      cur_transfer.eop = 1;
			   } else {
			      cur_transfer.sop = 0;
			      cur_transfer.eop = 0;
			   };
			   cur_transfer.data[7:0] = incoming_spi3_packet.data[i];
			   cur_data.add(deep_copy(cur_transfer));
			   cur_transfer=new;
		     	};
		     };//else
		  };
	        };//if incoming_spi3_packet.data.size() != 0
                emit port_driver.item_done;                // Indicate to the driver that the item is complete
            };//if not data_avail
//            wait cycle;
//        };//while TRUE
    };


    //-------------------------------------------------------------------
    // Function: get_bfm_data()
    //-------------------------------------------------------------------
    // This function determines the next data item (and associated control
    // fields) to be sent to the BFM when it requests more data for
    // delivery to the DUT.  The result of this method is used in the
    // BFM data sequence driver to constrain the sequence return value
    // if no user-defined data/control fields are present which would
    // override the default eVC behavior.  It should be noted that the
    // port arbitration unit will not allow the BFM to request data from
    // a port which has no data available (i.e. the data available flag
    // for each port figures into the arbitration algorithm).
    //-------------------------------------------------------------------
    get_bfm_data() : shr_spi3_inport_bfmdata_s is also {
      result = cur_data.pop0();
      if cur_data.size() == 0 then {
      	 data_avail = FALSE;
	 start manage_port_data();
      };
   };   




};

'>
