<'
package shr_spi3;

extend TX'direction shr_spi3_agent_u {
    sig_tsx   : inout simple_port of bit is instance;
    keep soft bind(sig_tsx, empty);
    sig_tenb  : inout simple_port of bit is instance;
    keep soft bind(sig_tenb, empty);
    sig_tsop  : inout simple_port of bit is instance;
    keep soft bind(sig_tsop, empty);
    sig_teop  : inout simple_port of bit is instance;
    keep soft bind(sig_teop, empty);
    sig_terr  : inout simple_port of bit is instance;
    keep soft bind(sig_terr, empty);
    sig_tprty : inout simple_port of bit is instance;
    keep soft bind(sig_tprty, empty);
    sig_tdat  : inout simple_port of uint is instance;
    keep soft bind(sig_tdat, empty);
    keep soft sig_tdat.declared_range() == "[31:0]";
    sig_tmod  : inout simple_port of uint(bits:2) is instance;
    keep soft bind(sig_tmod, empty);
    keep soft sig_tmod.declared_range() == "[1:0]";
    sig_tadr  : inout simple_port of uint is instance;
    keep soft bind(sig_tadr, empty);
    sig_stpa  : inout simple_port of bit is instance;
    keep soft bind(sig_stpa, empty);
    sig_ptpa  : inout simple_port of bit is instance;
    keep soft bind(sig_ptpa, empty);
    sig_dtpa  : inout simple_port of uint is instance;
    keep soft bind(sig_dtpa, empty);
    sig_tclk  : in simple_port of bit is instance;
    keep soft bind(sig_tclk, empty);
    sig_tf_rst_l  : in simple_port of bit is instance;
    keep soft bind(sig_tf_rst_l, empty);

    
    event clock is only rise(sig_tclk$)@sim;
    event reset_end is only rise(sig_tf_rst_l$)@sim;
};

extend RX'direction shr_spi3_agent_u {
    sig_rsx   : inout simple_port of bit is instance;
    keep soft bind(sig_rsx, empty);
    sig_rval  : inout simple_port of bit is instance;
    keep soft bind(sig_rval, empty);
    sig_renb  : inout simple_port of bit is instance;
    keep soft bind(sig_renb, empty);
    sig_rsop  : inout simple_port of bit is instance;
    keep soft bind(sig_rsop, empty);
    sig_reop  : inout simple_port of bit is instance;
    keep soft bind(sig_reop, empty);
    sig_rerr  : inout simple_port of bit is instance;
    keep soft bind(sig_rerr, empty);
    sig_rprty : inout simple_port of bit is instance;
    keep soft bind(sig_rprty, empty);
    sig_rdat  : inout simple_port of uint(bits:SHR_SPI3_MAX_BUS_WIDTH) is instance;
    keep soft sig_rdat.declared_range() == "[31:0]";
    keep soft bind(sig_rdat, empty);
    sig_rmod  : inout simple_port of uint(bits:2) is instance;
    keep soft sig_rmod.declared_range() == "[1:0]";    
    keep soft bind(sig_rmod, empty);
    sig_rclk  : in simple_port of bit is instance;
    keep soft bind(sig_rclk, empty);
    sig_rf_rst_l  : in simple_port of bit is instance;
    keep soft bind(sig_rf_rst_l, empty);
    
    event clock is only rise(sig_rclk$)@sim;
    event reset_end is only rise(sig_rf_rst_l$)@sim;   

};   

'>
extend LINK'layer RX'direction shr_spi3_agent_u {
    sig_rsx   : in simple_port of bit is instance;
    keep soft bind(sig_rsx, empty);
    sig_rval  : in simple_port of bit is instance;
    keep soft bind(sig_rval, empty);
    sig_renb  : inout simple_port of bit is instance;
    keep soft bind(sig_renb, empty);
    sig_rsop  : in simple_port of bit is instance;
    keep soft bind(sig_rsop, empty);
    sig_reop  : in simple_port of bit is instance;
    keep soft bind(sig_reop, empty);
    sig_rerr  : in simple_port of bit is instance;
    keep soft bind(sig_rerr, empty);
    sig_rprty : in simple_port of bit is instance;
    keep soft bind(sig_rprty, empty);
    sig_rdat  : in simple_port of uint is instance;
    keep soft bind(sig_rdat, empty);
    keep soft sig_rdat.declared_range() == "[31:0]";
    sig_rmod  : in simple_port of uint(bits:2) is instance;
    keep soft bind(sig_rmod, empty);
    keep soft sig_rmod.declared_range() == "[1:0]";
    sig_rclk  : in simple_port of bit is instance;
    keep soft bind(sig_rclk, empty);
    sig_rf_rst_l  : in simple_port of bit is instance;
    keep soft bind(sig_rf_rst_l, empty);
    
    event clock is only rise(sig_rclk$);
    event reset_end is only rise(sig_rf_rst_l$);   
};
extend PHY'layer TX'direction shr_spi3_agent_u {
    sig_tsx   : in simple_port of bit is instance;
    keep soft bind(sig_tsx, empty);
    sig_tenb  : in simple_port of bit is instance;
    keep soft bind(sig_tenb, empty);
    sig_tsop  : in simple_port of bit is instance;
    keep soft bind(sig_tsop, empty);
    sig_teop  : in simple_port of bit is instance;
    keep soft bind(sig_teop, empty);
    sig_terr  : in simple_port of bit is instance;
    keep soft bind(sig_terr, empty);
    sig_tprty : in simple_port of bit is instance;
    keep soft bind(sig_tprty, empty);
    sig_tdat  : in simple_port of uint(bits:SHR_SPI3_MAX_BUS_WIDTH) is instance;
    keep soft bind(sig_tdat, empty);
    sig_tmod  : in simple_port of uint(bits:2) is instance;
    keep soft bind(sig_tmod, empty);
    sig_tadr  : in simple_port of byte is instance;
    keep soft bind(sig_tadr, empty);
    sig_stpa  : inout simple_port of bit is instance;
    keep soft bind(sig_stpa, empty);
    sig_ptpa  : inout simple_port of bit is instance;
    keep soft bind(sig_ptpa, empty);
    sig_dtpa  : inout simple_port of uint is instance;
    keep soft bind(sig_dtpa, empty);
    sig_tclk  : in simple_port of bit is instance;
    keep soft bind(sig_tclk, empty);
};
