<'
unit shr_spi3_scoreboard_u like any_unit {

   port_id : uint;
   
   !scored_packets : list of shr_spi3_packet_s;
   
   score_item(pkt : shr_spi3_packet_s) is {
   
      scored_packets.add(deep_copy(pkt));
      if scored_packets.size() > 0 and get_objection_counter(TEST_DONE) == 0 then {
      	 raise_objection(TEST_DONE);
      };
   
   };//score_item
   
   remove_item(pkt : shr_spi3_packet_s) is {
   
      if pkt.data == scored_packets[0].data then {
	 scored_packets.delete(0);
	 messagef(MEDIUM,"Packet found on the scoreboard %d.\n",port_id);
      } else {
      	 outf("\n\nDUT Error on port %d\n\n", port_id);
	 outf("Expected Data:\n");
      	 print scored_packets[0].data using hex;
	 outf("\nReceived Data:\n");
	 print pkt.data using hex;
      	 dut_error("Packet mismatch on scoreboard.");
      };
      
      if scored_packets.size() == 0 then {
      	 drop_objection(TEST_DONE);
      };
   
   };
   

};


extend OUT shr_spi3_port_u {

   env : shr_spi3_env_u;
   keep env == get_enclosing_unit(shr_spi3_env_u);

   scoreboard : shr_spi3_scoreboard_u is instance;
   keep scoreboard.port_id == port_id;
      
   on new_pkt_generated {
      scoreboard.score_item(deep_copy(incoming_spi3_packet));
   };

};//extend OUT shr_spi3_port_u

extend IN shr_spi3_port_u {

   env : shr_spi3_env_u;
   keep env == get_enclosing_unit(shr_spi3_env_u);
   
   !scoreboard : shr_spi3_scoreboard_u;
   
   on pkt_received {
      scoreboard.remove_item(deep_copy(recd_pkts.top()));
   };

};//extend IN shr_spi3_port_u

//connect scoreboard reference in the IN ports to the scoreboard instance
//in the OUT ports

extend IN LINK shr_spi3_port_u {
   run() is also {
      if env.spi3_agents.first(it.direction == RX and it.layer == PHY)
          .data_ports.first(it.port_id == port_id) is an OUT shr_spi3_port_u (port_inst) then {
	    scoreboard = port_inst.scoreboard;
      };
   };
};//extend IN LINK shr_spi3_port_u

extend IN PHY shr_spi3_port_u {
   run() is also {
      if env.spi3_agents.first(it.direction == TX and it.layer == LINK)
          .data_ports.first(it.port_id == port_id) is an OUT shr_spi3_port_u (port_inst) then {
	    scoreboard = port_inst.scoreboard;
      };
   };
};//extend IN PHY shr_spi3_port_u


'>
